{
Client Access Objects 1.5

Data Queue demo using TcaoDataQueue.

(c) 1998, 1999 Steven P. Goldsmith
All Rights Reserved

Create data queue, write records, read records and delete keyed data queue.
Change constants to suit your system, library and queue name.

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 1, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

sgoldsmith@home.com
http://members.home.net/sgoldsmith/
}

unit DataQueueMain;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, ComCtrls,
  caoErrorMessage, caoDataQueueDataAttr, caoDataQueueAttr, caoDataQueue,
  caoCommonUtils;

//  Make sure you change this to your system name.

const
  As400Name = 'GEMINI';
  As400Lib = 'QTEMP';
  AS400QueueName = 'test';

type
  TMainForm = class(TForm)
    StatusLine: TStatusBar;
    RichEdit1: TRichEdit;
    caoDataQueue1: TcaoDataQueue;
    caoDataQueueAttr1: TcaoDataQueueAttr;
    caoDataQueueDataAttr1: TcaoDataQueueDataAttr;
    caoErrorMessage1: TcaoErrorMessage;
    MainMenu1: TMainMenu;
    DataQueue1: TMenuItem;
    Create1: TMenuItem;
    procedure WriteQueue(K, Data: string);
    function ReadQueue(K: string): string;
    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Create1Click(Sender: TObject);
    procedure caoDataQueue1Close(Sender: TObject);
    procedure caoDataQueue1Open(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

{
Write to currently open data queue.
}

procedure TMainForm.WriteQueue(K, Data: string);
var
  Key: OleVariant;
  OutBuf: OleVariant;
begin
  RichEdit1.Lines.Add(Format('Writing "%s" using key "%s"',[Data,K]));
  with caoDataQueue1 do
  begin
    Key := StrToVarByte(K);
    caoDataQueueDataAttr1.SetKey(Key,Length(K));
    OutBuf := StrToVarByte(Data);
    Write(OutBuf,Length(Data),False)
  end
end;

{
Read from currently open queue.
}

function TMainForm.ReadQueue(K: string): string;
var
  Key: OleVariant;
  InBuf: OleVariant;
  InLen: Integer;
  S: string;
begin
  with caoDataQueue1 do
  begin
    Key := StrToVarByte(K);
    caoDataQueueDataAttr1.SetKey(Key,Length(K));
    InBuf := VarArrayCreate([0,caoDataQueueAttr1.maxRecordLength-1],varByte);
    Read(InBuf,InLen,0);
    S := VarByteToStr(InBuf);
    SetLength(S,InLen)
  end;
  RichEdit1.Lines.Add(Format('Read "%s" from queue using key "%s"',[S,K]));
  Result := S
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowHint;
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  StatusLine.SimpleText := Application.Hint;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  caoErrorMessage1.Setup;
  caoDataQueueAttr1.Setup;
  caoDataQueueDataAttr1.Setup
end;

{
Create queue, write various values, read back in keyed sequence and delete
queue.
}

procedure TMainForm.Create1Click(Sender: TObject);
begin
  with caoDataQueue1 do
  begin
    CreateQ(As400QueueName,As400Lib,As400Name);
    Open(As400QueueName,As400Lib,As400Name);
    WriteQueue('500       ','Test queue data for key 500');
    WriteQueue('100       ','Test queue data for key 100');
    WriteQueue('300       ','Test queue data for key 300');
    ReadQueue('100       ');
    ReadQueue('300       ');
    ReadQueue('500       ');
    Close;
    Delete(As400QueueName,As400Lib,As400Name)
  end
end;

procedure TMainForm.caoDataQueue1Close(Sender: TObject);
begin
  RichEdit1.Lines.Add('OnClose')
end;

procedure TMainForm.caoDataQueue1Open(Sender: TObject);
begin
  RichEdit1.Lines.Add('OnOpen')
end;

end.
